<?php

/**
 * 接收金立后台通知(支付)充值后的回调处理，不需要手动运行。运行地址要注册到创建订单中，
 * @version
 *          1.0.0 Created at 2017-12-30. by --gwang
 * @author gwang (mail@wanggangzero.cn)
 * @copyright ? 2017-12-30, SJZ LoyalSoft Corporation & gwang. All rights reserved.
 *
 */
include_once __DIR__ . '/../../../main.php';                                    # 导入game utils
include_once __DIR__ . '/../Mo/resp.php';                                       # 导入通用返回值结构
include_once __DIR__ . '/../Mo/payRequest.php';                                 # 导入通用返回值结构
require_once __DIR__ . '/../Mo/OrderNotice.php';
require_once __DIR__ . '/config_for_gionee.php';                                # 配置文件,

use loyalsoft\CLog;
use loyalsoft\HttpUtil;
use loyalsoft\pay\OrderNotice;

try {
    $params = HttpUtil::getQueryParas();                                        # 请求数组
    CLog::pay("[notify.金立]收到支付回调请求: " . HttpUtil::getQueryString()); # 日志
    $cfg = config_for_gionee::Inst();                                           # 配置信息
    if (!$cfg->notify_rsa_verify($params)) {                                    # 校验签名
        CLog::pay("[notify.金立]" . " 验签失败! ");
        die('error sign');                                                      # 签名验证不通过
    }
    $order = OrderNotice::Parse_gionee($params);                                # 将参数归一化到order
//    var_dump($order);
    if ($order != null) {
        if ($order->Check()) {                                                  # 订单校验,
            if ($order->status == 1) {                                          # 订单状态是成功
                $order->UpdateOrderStatus();                                    # 更新订单状态,->已付款
                CLog::pay("[notify.金立] [发货] 订单: " . $order->cpOrderId . ", 金额: " . $order->amount);
            } else if ($order->status == 2) {                                   # status为2(failed)的情况
                $order->UpdateOrderStatus();                                    # 直接更新订单状态,->支付失败
                CLog::pay("[notify.金立] [不发货] 订单: " . $order->cpOrderId);
            } else {
                CLog::pay("[notify.金立][处理结果]: FAILURE (未知的支付状态)"); # 日志
                die('FAILURE');
            }
            CLog::pay("[notify.金立][处理结果]:" . "SUCCESS");                # 日志
            exit('success');                                                    # 返回给sdk server的响应内容
        }
    }
    CLog::pay("[notify.金立][处理结果]:" . "FAILURE");                        # 日志
    die('FAILURE');           //返回给sdk server的响应内容 ,对于重复多次通知失败的订单,请参考文档中通知机制。
} catch (Exception $e) {
    CLog::pay("[notify.金立]" . $e->getMessage());                           # 日志
    throw new exception($e->getMessage());
}